<?php
namespace Snog\Flags\Cron;

use XF\Util\File;

class Maxmind
{
	public static function Update()
	{
		$tempDir = FILE::getTempDir();

		$tempPath = $tempDir . DIRECTORY_SEPARATOR . 'GeoLite2-Country.mmdb.gz';
		$unzippedFile = str_ireplace('.gz','', $tempPath);
		$finalPath = 'data://countryflags/GeoLite2-Country.mmdb';

		try
		{
			// Attempt to connect to MaxMind for the database
			$response = \XF::app()->http()->client()->get('http://geolite.maxmind.com/download/geoip/database/GeoLite2-Country.mmdb.gz');
			file_put_contents($tempPath, (string)$response->getBody());
		}
		catch(\GuzzleHttp\Exception\RequestException $e)
		{
			exit;
		}

		$buffer = 4096;
		$zip = gzopen($tempPath, 'rb');

		if($zip !== false)
		{
			$fp = fopen($unzippedFile, 'wb');

			while(!gzeof($zip))
			{
				fwrite($fp, gzread($zip, $buffer));
			}

			fclose($fp);
			gzclose($zip);
			unlink($tempPath);

			File::copyFileToAbstractedPath($unzippedFile, $finalPath);
			unlink($unzippedFile);
		}
	}
}